freeslot("SPR2_BTSA")
spr2defaults[SPR2_BTSA] = SPR2_STND
freeslot("S_BTAILS_SAD")

freeslot("SPR2_BPSE")
spr2defaults[SPR2_BPSE] = SPR2_STND
freeslot("S_BSONIC_POSE")

states[S_BTAILS_SAD] = {
	sprite = SPR_PLAY,
	frame = SPR2_BTSA,
	tics = 10,
	var1 = PA_IDLE,
	action = A_SetPAnim,
	nextstate = S_BTAILS_SAD
}

states[S_BSONIC_POSE] = {
	sprite = SPR_PLAY,
	frame = SPR2_BPSE,
	tics = 10,
	var1 = PA_IDLE,
	action = A_SetPAnim,
	nextstate = S_BSONIC_POSE
}

local function setEmoteVars(player)
	--saving last variables
	player.bmX = player.mo.x
	player.bmY = player.mo.y
	player.bmZ = player.mo.z
	player.bmState = player.mo.state --so we can switch back to our last state
end

local function handleEmoteState(player)
	--for older versions
	--make sure they support it
	if (P_MoveOrigin) then
		P_MoveOrigin(player.mo, player.bmX, player.bmY, player.bmZ)
	else
		P_TeleportMove(player.mo, player.bmX, player.bmY, player.bmZ)
	end
	if (player.cmd.buttons & BT_JUMP) then
		player.mo.state = player.bmState
	end
end

addHook("ThinkFrame", function()
	for player in players.iterate do
		if (player.mo) then
			if (player.mo.skin == "bsonic") or (player.mo.skin == "btails") then
					if (player.cmd.buttons & BT_CUSTOM2) and (P_IsObjectOnGround(player.mo)) then
						if not (player.mo.state == S_BTAILS_SAD) then
							setEmoteVars(player)
							--do the emote
							player.mo.state = S_BTAILS_SAD
						end
					end
					if (player.cmd.buttons & BT_CUSTOM1) and (P_IsObjectOnGround(player.mo)) then
						if not (player.mo.state == S_BSONIC_POSE) then
							setEmoteVars(player)
							--do the emote
							player.mo.state = S_BSONIC_POSE
						end
					end
					--emote handlers
					if (player.mo.state == S_BSONIC_POSE) then
						handleEmoteState(player)
					end
					if (player.mo.state == S_BTAILS_SAD) then
						handleEmoteState(player)
					end
				end
			end
		end
end)

hud.add(function (v, player)
	if (player.mo) then
		if (player.mo.state == S_BTAILS_SAD)
		or (player.mo.state == S_BSONIC_POSE)
		then
			--small reminder
			v.drawString(160, 180, ("Press jump to exit emote"),V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|V_YELLOWMAP, "thin-center")
		end
	end
end, "game")